<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPieceBarcode ArrayType
 * @subpackage Arrays
 */
class ArrayOfPieceBarcode extends AbstractStructArrayBase
{
    /**
     * The PieceBarcode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PieceBarcode[]
     */
    public $PieceBarcode;
    /**
     * Constructor method for ArrayOfPieceBarcode
     * @uses ArrayOfPieceBarcode::setPieceBarcode()
     * @param \StructType\PieceBarcode[] $pieceBarcode
     */
    public function __construct(array $pieceBarcode = array())
    {
        $this
            ->setPieceBarcode($pieceBarcode);
    }
    /**
     * Get PieceBarcode value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PieceBarcode[]|null
     */
    public function getPieceBarcode()
    {
        return isset($this->PieceBarcode) ? $this->PieceBarcode : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPieceBarcode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPieceBarcode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePieceBarcodeForArrayConstraintsFromSetPieceBarcode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPieceBarcodePieceBarcodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfPieceBarcodePieceBarcodeItem instanceof \StructType\PieceBarcode) {
                $invalidValues[] = is_object($arrayOfPieceBarcodePieceBarcodeItem) ? get_class($arrayOfPieceBarcodePieceBarcodeItem) : sprintf('%s(%s)', gettype($arrayOfPieceBarcodePieceBarcodeItem), var_export($arrayOfPieceBarcodePieceBarcodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PieceBarcode property can only contain items of type \StructType\PieceBarcode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PieceBarcode value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PieceBarcode[] $pieceBarcode
     * @return \ArrayType\ArrayOfPieceBarcode
     */
    public function setPieceBarcode(array $pieceBarcode = array())
    {
        // validation for constraint: array
        if ('' !== ($pieceBarcodeArrayErrorMessage = self::validatePieceBarcodeForArrayConstraintsFromSetPieceBarcode($pieceBarcode))) {
            throw new \InvalidArgumentException($pieceBarcodeArrayErrorMessage, __LINE__);
        }
        if (is_null($pieceBarcode) || (is_array($pieceBarcode) && empty($pieceBarcode))) {
            unset($this->PieceBarcode);
        } else {
            $this->PieceBarcode = $pieceBarcode;
        }
        return $this;
    }
    /**
     * Add item to PieceBarcode value
     * @throws \InvalidArgumentException
     * @param \StructType\PieceBarcode $item
     * @return \ArrayType\ArrayOfPieceBarcode
     */
    public function addToPieceBarcode(\StructType\PieceBarcode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PieceBarcode) {
            throw new \InvalidArgumentException(sprintf('The PieceBarcode property can only contain items of type \StructType\PieceBarcode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PieceBarcode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PieceBarcode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PieceBarcode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PieceBarcode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PieceBarcode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PieceBarcode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PieceBarcode
     */
    public function getAttributeName()
    {
        return 'PieceBarcode';
    }
}
